%      
function dy = F_xyz(t, Y)
global mu R3 m;

dx=Y(1);
x=Y(2);
dy=Y(3);
y=Y(4);
dz=Y(5);
z=Y(6);

r=sqrt(x^2+y^2+z^2);

%      
C1=y*dz-z*dy;
C2=z*dx-x*dz;
C3=x*dy-y*dx;
C=sqrt(C1^2+C2^2+C3^2);
nx=C1/C;
ny=C2/C;
nz=C3/C;

FT=100; % tau
FW=50; % C
FS=25; % r

Cij=[(C2*z-C3*y)/C/r,nx,x/r;
     (C3*x-C1*z)/C/r,ny,y/r;
     (C1*y-C2*x)/C/r,nz,z/r];
 F=Cij*[FT;FW;FS];

Fx=F(1,1);
Fy=F(2,1);
Fz=F(3,1);

ddx=-mu*x/r^3+Fx/m;
ddy=-mu*y/r^3+Fy/m;
ddz=-mu*z/r^3+Fz/m;

[t r]
dy=[ddx;dx;ddy;dy;ddz;dz];