clear
global mu R3 m E0;
mu = 3.986004415*10^14;
R3 = 6371000;
m=1000;


e0=0.01;
a0=R3+500000;
Omega0=0;
omega0=0;
f0=0;
I0=30*pi/180;
theta0=omega0+f0;
p0=a0*(1-e0^2);
r0=p0/(1+e0*cos(f0));

E0=2*atan(tan(f0/2)*sqrt((1-e0)/(1+e0)));
M0=E0-e0*sin(E0);

Vr0=sqrt(mu/p0)*e0*sin(f0);
Vtheta0=sqrt(mu/p0)*(1+e0*cos(f0));

x0=r0*(cos(Omega0)*cos(theta0)-sin(Omega0)*sin(theta0)*cos(I0));
y0=r0*(sin(Omega0)*cos(theta0)+cos(Omega0)*sin(theta0)*cos(I0));
z0=r0*sin(theta0)*sin(I0);

dx0=Vr0*(cos(Omega0)*cos(theta0)-sin(Omega0)*sin(theta0)*cos(I0))-Vtheta0*(cos(Omega0)*sin(theta0)+sin(Omega0)*cos(theta0)*cos(I0));
dy0=Vr0*(sin(Omega0)*cos(theta0)+cos(Omega0)*sin(theta0)*cos(I0))-Vtheta0*(sin(Omega0)*sin(theta0)-cos(Omega0)*cos(theta0)*cos(I0));
dz0=Vr0*sin(theta0)*sin(I0)+Vtheta0*cos(theta0)*sin(I0);


y0_xyz=[dx0;x0;dy0;y0;dz0;z0];
y0_oe=[a0;e0;I0;Omega0;omega0;M0];
y0_oe2=[a0;e0;I0;Omega0;omega0;f0];

options = odeset('RelTol',1e-7,'AbsTol',1e-10);
tk=12000; 
tspan=0:10:tk;
tic;
[Tx,Yx] = ode45(@F_xyz,tspan,y0_xyz,options);
TimeX=toc;
tic
[Te,Ye] = ode45(@F_oe,tspan,y0_oe,options); 
TimeOE=toc;
tic
[Te2,Ye2] = ode45(@F_oe2,tspan,y0_oe2,options); 
TimeOE2=toc;
dx=Yx(:,1);
x=Yx(:,2);
dy=Yx(:,3);
y=Yx(:,4);
dz=Yx(:,5);
z=Yx(:,6);
r=sqrt(x.^2+y.^2+z.^2);
plot3(x,y,z)

a=Ye(:,1);
e=Ye(:,2);
I=Ye(:,3);
Omega=Ye(:,4);
omega=Ye(:,5);
M=Ye(:,6);
E0=2*atan(tan(f0/2)*sqrt((1-e0)/(1+e0)));
for j=1:length(Te)
   E(j)=fsolve(@(xE)(M(j)-xE+e(j)*sin(xE)),E0);
   E0=E(j);
   f(j,1)=2*atan(sqrt((1+e(j))/(1-e(j)))*tan(E(j)/2));
   re(j,1)=a(j)*(1-e(j)*cos(E(j)));  
   p(j)=a(j)*(1-e(j)^2);
   re1(j,1)=p(j)/(1+e(j)*cos(f(j,1)));;
end;
theta=omega+f;

xe=re.*(cos(Omega).*cos(theta)-sin(Omega).*sin(theta).*cos(I));
ye=re.*(sin(Omega).*cos(theta)+cos(Omega).*sin(theta).*cos(I));
ze=re.*sin(theta).*sin(I);
plot(Tx,r,Te,re,'k--')